import { BaseNode as ShaderBaseNode, DataType } from './ast/glsl-tree';
import { ArrayExpression, CallExpression, Expression, MemberExpression } from './ast/ts-estree';
/**
 * 根据表达式进行类型推导
 * 尽管在 TS 的基础上扩充了基础数据类型 Scalar/Vector/Matrix，但我们希望用户可以尽量少的显式声明变量类型
 */
export declare class DataTypeInference {
    infer(expression: Expression | null, scopeNode?: ShaderBaseNode): DataType;
    inferArrayExpression(expression: ArrayExpression, scopeNode?: ShaderBaseNode): DataType;
    inferCallExpression(expression: CallExpression, scopeNode?: ShaderBaseNode): DataType;
    inferMemberExpression(expression: MemberExpression, scopeNode?: ShaderBaseNode): DataType;
}
