import { GLSLContext } from '@antv/g-webgpu-core';
import { DataType, Program as ShaderProgram } from './ast/glsl-tree';
import { Program } from './ast/ts-estree';
import { Target } from './backends/ICodeGenerator';
export declare const dataTypeMap: Record<string, DataType>;
/**
 * 将 ESTree 转换成 ShaderTree，同时完成 Scope 创建
 */
export declare class Transformer {
    target: Target;
    private inference;
    private context;
    transform(program: Program, context?: GLSLContext): ShaderProgram;
    private addBuiltinVariablesToRootScope;
    private transformStatement;
    private transformExpression;
    private transformIdentifier;
    private transformDoWhileStatement;
    private transformWhileStatement;
    private transformForStatement;
    private transformVariableDeclaration;
    private transformFunctionDeclaration;
    private transformIfStatement;
    private transformClassDeclaration;
    private analyzeDecorators;
    private extractDecorator;
}
