import _defineProperty from "@babel/runtime/helpers/defineProperty";

var _importFunctions, _exportFunctions;

import { AST_TOKEN_TYPES } from '../ast/glsl-ast-node-types';
import { Target } from '../backends/ICodeGenerator'; // http://learnwebgl.brown37.net/12_shader_language/glsl_data_types.html

export var typeCastFunctions = ['float', 'int', 'uint', 'vec2', 'vec3', 'vec4', 'bool', 'ivec2', 'ivec3', 'ivec4', 'bvec2', 'bvec3', 'bvec4', 'mat2', 'mat3', 'mat4'];
export var builtinFunctions = ['radians', 'degrees', 'sin', 'cos', 'tan', 'asin', 'acos', 'atan', 'pow', 'exp', 'log', 'exp2', 'log2', 'sqrt', 'abs', 'sign', 'floor', 'ceil', 'min', 'max', 'normalize', 'distance']; // https://stackoverflow.com/questions/12085403/whats-the-logic-for-determining-a-min-max-vector-in-glsl
// https://www.khronos.org/registry/OpenGL/specs/gl/GLSLangSpec.4.30.pdf

export var componentWiseFunctions = ['radians', 'degrees', 'sin', 'cos', 'tan', 'asin', 'acos', 'atan', 'pow', 'exp', 'log', 'exp2', 'log2', 'sqrt', 'abs', 'sign', 'floor', 'ceil', 'min', 'max'];
export var swizzling = ['r', 'g', 'b', 'a', 'x', 'y', 'z', 'w', 's', 't', 'p', 'q'];
export var typePriority = {
  float: 1,
  int: 2,
  uint: 3,
  vec2: 100,
  vec3: 101,
  vec4: 102
};
export var importFunctions = (_importFunctions = {}, _defineProperty(_importFunctions, Target.GLSL100, "\nfloat epsilon = 0.00001;\nvec2 addrTranslation_1Dto2D(float address1D, vec2 texSize) {\n  vec2 conv_const = vec2(1.0 / texSize.x, 1.0 / (texSize.x * texSize.y));\n  vec2 normAddr2D = float(address1D) * conv_const;\n  return vec2(fract(normAddr2D.x + epsilon), normAddr2D.y);\n}\n\nvoid barrier() {}\n  "), _defineProperty(_importFunctions, Target.GLSL450, ''), _defineProperty(_importFunctions, Target.WGSL, ''), _importFunctions);
export var exportFunctions = (_exportFunctions = {}, _defineProperty(_exportFunctions, Target.GLSL100, {
  debug: {
    content: "\nvoid debug(vec4 o) {\n  gWebGPUDebug = true;\n  gWebGPUDebugOutput = o;\n}\nvoid debug(vec3 o) {\n  debug(vec4(o.xyz, 0.0));\n}\nvoid debug(vec2 o) {\n  debug(vec4(o.xy, 0.0, 0.0));\n}\nvoid debug(ivec4 o) {\n  debug(vec4(o));\n}\nvoid debug(ivec3 o) {\n  debug(vec4(o.xyz, 0.0));\n}\nvoid debug(ivec2 o) {\n  debug(vec4(o.xy, 0.0, 0.0));\n}\nvoid debug(float o) {\n  debug(vec4(o, 0.0, 0.0, 0.0));\n}\nvoid debug(int o) {\n  debug(vec4(o, 0.0, 0.0, 0.0));\n}\nvoid debug(bool o) {\n  debug(vec4(o, 0.0, 0.0, 0.0));\n}\n",
    returnType: AST_TOKEN_TYPES.Void
  }
}), _defineProperty(_exportFunctions, Target.GLSL450, {
  debug: {
    content: "\nvoid debug(vec4 o) {\n  gWebGPUDebug = true;\n  gWebGPUDebugOutput = o;\n}\nvoid debug(vec3 o) {\n  debug(vec4(o.xyz, 0.0));\n}\nvoid debug(vec2 o) {\n  debug(vec4(o.xy, 0.0, 0.0));\n}\nvoid debug(ivec4 o) {\n  debug(vec4(o));\n}\nvoid debug(ivec3 o) {\n  debug(vec4(o.xyz, 0.0));\n}\nvoid debug(ivec2 o) {\n  debug(vec4(o.xy, 0.0, 0.0));\n}\nvoid debug(float o) {\n  debug(vec4(o, 0.0, 0.0, 0.0));\n}\nvoid debug(int o) {\n  debug(vec4(o, 0.0, 0.0, 0.0));\n}\nvoid debug(bool o) {\n  debug(vec4(o, 0.0, 0.0, 0.0));\n}\n",
    returnType: AST_TOKEN_TYPES.Void
  }
}), _defineProperty(_exportFunctions, Target.WGSL, {}), _exportFunctions);
//# sourceMappingURL=builtin-functions.js.map