import { BaseNode as ShaderBaseNode, DataType } from '../ast/glsl-tree';
export declare function isLeft(node: ShaderBaseNode): boolean;
export declare function isScalar(dt: DataType): boolean;
export declare function isVector(dt: DataType): boolean;
export declare function isMatrix(dt: DataType): boolean;
export declare function isArray(dt: DataType): boolean;
export declare function getComponentSize(dt: DataType): number;
export declare function getByteCount(dt: DataType): number;
/**
 * 从向量/矩阵数据类型中获取每个分量的数据类型
 * eg. vec2 -> float
 *     ivec2 -> int
 *     bvec4 -> bool
 *     mat3 -> float
 * vec4[] -> vec4
 * @param dt 向量类型
 */
export declare function getComponentDataTypeFromVector(dt: DataType): DataType;
export declare const typePriority: Record<DataType, number>;
/**
 * 用于强制类型转换
 * eg. float + int -> int(float) + int
 *     float + vec3 -> vec3(float) + vec3
 * @param type1 dt1
 * @param type2 dt2
 */
export declare function compareDataTypePriority(type1: DataType, type2: DataType): DataType;
