import { BaseNode as ShaderBaseNode, Identifier, Identifier as ShaderIdentifier } from '../ast/glsl-tree';
export declare function addIdentifierToScope(node: ShaderBaseNode, id: ShaderIdentifier, isFunction?: boolean): void;
/**
 * 从当前节点向上查找，也要考虑别名
 * @param node 当前节点
 * @param idName id 名称
 */
export declare function getIdentifierFromScope(node: ShaderBaseNode, idName: string, isFunction?: boolean): ShaderIdentifier | undefined;
/**
 * 从当前节点向上查找，也要考虑别名
 * @param node 当前节点
 * @param idName id 名称
 */
export declare function getScopeByIdentifierName(node: ShaderBaseNode, idName: string, isFunction?: boolean): {
    id: Identifier;
    alias: string[];
    isFunction: boolean;
} | undefined;
export declare function traverseUpwards<T>(node: ShaderBaseNode, test: (node: ShaderBaseNode) => undefined | T): undefined | T;
